import React, { useEffect, useState } from 'react';
import './App.scss';



const Input = () => {
  const [text, setText] = useState('text');
  return <div>
    <h1>{text}</h1>
    <input value={text} onChange={e => setText(e.target.value)} />
  </div>
  
}
const LoginForm = ({onLogin}) => {
  const [login, setLogin] = useState('');
  const [pswd, setPswd] = useState('');

  return <div>
      <input value={login} onChange={e => setLogin(e.target.value)}/> 
      <input value={pswd} onChange={e => setPswd(e.target.value)}/>
      <button disabled={login.length<3 || pswd.length<8 ? true:""} onClick={() => onLogin(login,pswd)}>Login</button>   
  </div>
}

const Counter = ({ms=1000}) => {
  const [counter, setCounter] = useState(0)
  useEffect(() => {
   const interval = setInterval (() => setCounter(counter => counter+1), ms)
    return () => {
      console.log('DID UNMOUNT')
      clearInterval(interval)
    }
  }, [ms])
  /* setInterval (() => setCounter(counter+1), 1000) */
  return (
    <div>{counter}</div>
  )
}
const Spoiler = ({header="+",children, opened=true}) => {
  const [open, setOpen] = useState(opened)
  return (
    <div>
        <div onClick={()=>setOpen(!open)}>{header}</div>
        {open && children}
    </div>
  )
}

const Counters = () => {
  const [cntrs, setCntrs] = useState([])
  const [ms, setMs] = useState(1000)
  return (
    <div>
      <button onClick={() => setMs(ms+100)}>+</button>
      <button onClick={() => setMs(ms-100)}>-</button>
      {cntrs.map(() => <Counter/>)}
      <button onClick={() => setCntrs([...cntrs, cntrs.length])}>Add</button>
    </div>
  )
}

const RangeInput = ({min,max}) => {
  const [value, SetValue] = useState(0);
  let color = "white";
  
  /* useEffect(() => {
    if(value < min || value > max){
        color = "red";
        console.log(color);
    } else {
      color = '';
    }
  }, [value]) */
  if(value < min || value > max) {
    color = "red"
    
  } else {
    color = "";
  }
  return (
    <input onChange={e => SetValue(e.target.value.length)} style={{backgroundColor:color}}/>
  )
}

const PasswordConfirm = ({min}) => {

    const[value1,SetValue1] = useState('');
    const[value2,SetValue2] = useState('');
    let color = "";
    let pattern = /^[0-9a-zA-Z]+$/;
    if(value1.length > min && value2.length > min && value1.match(pattern) && value2.match(pattern) && value1 === value2)  {
      color="green"
    } else {
      color="red";
    }

    return(
      <div>
        <input type="password" onChange={e => SetValue1(e.target.value)} style={{borderColor:color}}/>
        <input type="password" onChange={e => SetValue2(e.target.value)} style={{borderColor:color}}/>
      </div>
    )
}

class Timer extends React.Component {
     
    constructor(props) {
      super(props)
      this.state = {seconds: 0,
                    minutes:0,
                    hour:0,
                    propsTime: props.time
                    }
      this.Pause = this.Pause.bind(this);
      this.tick = this.tick.bind(this);
    }
 
   static getDerivedStateFromProps(props, state){
     console.log('get derived state');
     return /* ({"date": props.time}) */ null 
   }
    
    componentDidMount() {
      this.timerID = setInterval(this.tick,1000)
    }

    Pause() {
      clearInterval(this.timerID);
    }
    

    tick() {
      let t = this.state.propsTime -1
      let hours = Math.floor(t/3600);
      let minutes = Math.floor((t - hours*3600)/60);
      let seconds = Math.floor(t - hours*3600-minutes*60)
      this.setState({
        seconds,minutes,hours, propsTime: t
      })
      /* this.setState({
        seconds: this.state.seconds - 1
      }) */
      /* console.log(t); */
      if (t <= 0){
        clearInterval(this.timerID)
      }
    }
    

  render() {
    const {seconds, minutes, hours} = this.state
    return(
      <div>
        <h1>TIMER</h1>
        <span>hours :{hours} </span>
        <span>minutes: {minutes} </span>
        <span>seconds: {seconds}</span>
        <button onClick={this.Pause}>Pause</button>
      </div>
    )
  }
}


function App () {
  return(
    <div className='App'>
      {/* <Input/> */}
      {/* <LoginForm onLogin={(login, password) => console.log(login,password)}/> */}
      <Spoiler header={<h1>Hello</h1>} opened={false}>
        <h1>Hello</h1>
        <p>blabla</p>
      </Spoiler>
      <RangeInput min={2} max={10}/>
      <PasswordConfirm min={2}/>
      <Timer time={10000}/>
    </div>
  );
}
export default App;
